#ifndef _HEX_H
#define _HEX_H

#include <algorithm>
#include <string>

//takes hex string
//returns decimal value of hex string
inline int hex_value(string x)
{
	if(x.length()<= 0)return -1;
	//x = uppercase(x);
	//std::transform(x.begin(), x.end(), x.begin(), ::toupper);

	if(x[0]>='0' && x[0]<='9') return x[0]-'0';
	else if(x[0]>='A' && x[0]<='F') return x[0]-'A';
	else if(x[0]>='a' && x[0]<='f') return x[0]-'a';

	return -1;
}

inline bool is_hex(string x)
{
	for(int i = 0; i<(int)x.length(); i++)
	{
		if(hex_value(x) == -1)
			return false;
	}
	return true;
}

//takes int or unsigned character
//returns hex value of character
inline string hex_char(int c)
{
	string a;
	char cBuf[6];
	sprintf(cBuf, "%02X ", (unsigned char) c); 
	//a = (string) cBuf;
	a += cBuf[0];
	a += cBuf[1];
	return a.substr(0,2);
}

//takes hex string
//returns character value of hex string
inline unsigned char char_hex(string hex)
{
	string x = hex.substr(0,1);
	string y = hex.substr(1,1);
	return (unsigned char) (( 16 * hex_value(x) ) + hex_value(y));
}

//takes start, end, buffer, filestream
//returns dumps hex from start to end into buffer
void hex_dump(fstream& fs, std::vector<std::string>& data, long start, long end)
{
	unsigned char c;
	int i = start;
	fs.seekg(start,ios::beg);
	while (!fs.eof() && i != end)
	{
		c = fs.get();
		data.push_back(hex_char(c));
		i++;
	}
}

//takes start, end, buffer, filestream
//returns replaces hex from start to end into file from buffer
void hex_overwrite(fstream& fs, std::vector<std::string>& data, long start, long end)
{
	int i = start;
	int j = 0;
	fs.seekg(start,ios::beg);
	while (!fs.eof() && i != end && j < (int)data.size())
	{
		fs.put((unsigned char) (char_hex(data[j])));
		i++;
		j++;
	}
}

#endif